#version 430 core

layout(quads, fractional_odd_spacing, ccw) in;

// Input variables
in VertexData
{
	vec3 position_ws;	// Position in world space
	vec3 tangent_ws;	// Tangent in world space
	vec3 bitangent_ws;	// Bitangent in world space
} inData[];

// Output variables
out VertexData
{
	vec3 position_ws;	// Position in world space
	vec3 normal_ws;		// Normal in world space
	vec2 tex_coord;
	vec3 tangent_ws;	// Tangent in world space
	vec3 bitangent_ws;	// Bitangent in world space
} outData;

// Data of the camera
layout (std140, binding = 0) uniform CameraData
{
	mat4 projection;		// Projection matrix
	mat4 projection_inv;	// Inverse of the projection matrix
	mat4 view;				// View matrix
	mat4 view_inv;			// Inverse of the view matrix
	mat3 view_it;			// Inverse of the transpose of the top-left part 3x3 of the view matrix
	vec3 eye_position;		// Position of the eye in world space
};

// Height texture and a scale applied to it
layout (binding = 2) uniform sampler2D height_tex;
uniform float height_scale;

// Amount of displacement, and whether to use it or not
const float max_displacement = 0.1f;
uniform bool use_displacement_mapping;

//----------------------------------------------------------------

void main()
{
	// Task 1: Evaluate the position of the vertex in the Bezier patch.
	//			Store the result into outData.position_ws
	//		Hint: Create functions bezier4 and bezier4x4. Patch coordinate is in gl_TessCoord.xy.

	// Task 2: Compute the texture coordinates, use the patch coordinates as texture coordinates.
	//			Store the result into outData.tex_coord

	// Task 3: Evaluate the tangent and bitangent of the vertex in the Bezier patch.
	//			Store the result into outData.tangent_ws/bitangent_ws
	//		Hint: Use the same functions as for the position

	// Task 3: Compute the normal as the cross product of the tangent and bitangent, and normalize it.
	//			Store the result into outData.normal_ws

	if (use_displacement_mapping)
	{
		// Task 5: Displace the vertex position
		//		Hint: function textureLod, texture height_tex, constant max_displacement, uniform height_scale
	}

	// Task 1: Compute gl_Position
	//		Hint: transform the vertex using projection and view matrices
}